/* FileSelector.c generated by valac 0.30.2, the Vala compiler
 * generated from FileSelector.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2016 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <pango/pango.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>


#define TYPE_FILE_SELECTOR (file_selector_get_type ())
#define FILE_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_FILE_SELECTOR, FileSelector))
#define FILE_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_FILE_SELECTOR, FileSelectorClass))
#define IS_FILE_SELECTOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_FILE_SELECTOR))
#define IS_FILE_SELECTOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_FILE_SELECTOR))
#define FILE_SELECTOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_FILE_SELECTOR, FileSelectorClass))

typedef struct _FileSelector FileSelector;
typedef struct _FileSelectorClass FileSelectorClass;
typedef struct _FileSelectorPrivate FileSelectorPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _FileSelector {
	GtkWindow parent_instance;
	FileSelectorPrivate * priv;
};

struct _FileSelectorClass {
	GtkWindowClass parent_class;
};

struct _FileSelectorPrivate {
	guint _max_file_size;
	GdkPixbuf* image;
	GtkFileChooserWidget* file_chooser;
	GtkBox* main_box;
	GtkBox* preview_box;
	GtkImage* preview_image;
	GtkLabel* preview_label;
	GtkButton* select_button;
	GtkButton* cancel_button;
};


static gpointer file_selector_parent_class = NULL;

GType file_selector_get_type (void) G_GNUC_CONST;
#define FILE_SELECTOR_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_FILE_SELECTOR, FileSelectorPrivate))
enum  {
	FILE_SELECTOR_DUMMY_PROPERTY,
	FILE_SELECTOR_MAX_FILE_SIZE
};
#define TWITTER_MAX_BYTES_PER_IMAGE ((1024 * 1024) * 3)
FileSelector* file_selector_new (void);
FileSelector* file_selector_construct (GType object_type);
static void file_selector_update_preview_cb (FileSelector* self);
static void _file_selector_update_preview_cb_gtk_file_chooser_update_preview (GtkFileChooser* _sender, gpointer self);
static void file_selector_selection_changed_cb (FileSelector* self);
static void _file_selector_selection_changed_cb_gtk_file_chooser_selection_changed (GtkFileChooser* _sender, gpointer self);
static void file_selector_file_activated_cb (FileSelector* self);
static void _file_selector_file_activated_cb_gtk_file_chooser_file_activated (GtkFileChooser* _sender, gpointer self);
static void file_selector_folder_changed_cb (FileSelector* self);
static void _file_selector_folder_changed_cb_gtk_file_chooser_current_folder_changed (GtkFileChooser* _sender, gpointer self);
static void file_selector_select_clicked_cb (FileSelector* self);
static void _file_selector_select_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void file_selector_cancel_clicked_cb (FileSelector* self);
static void _file_selector_cancel_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self);
static void file_selector_choose_file (FileSelector* self);
guint file_selector_get_max_file_size (FileSelector* self);
void file_selector_set_max_file_size (FileSelector* self, guint value);
static void g_cclosure_user_marshal_VOID__STRING_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static void file_selector_finalize (GObject* obj);
static void _vala_file_selector_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_file_selector_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


static void _file_selector_update_preview_cb_gtk_file_chooser_update_preview (GtkFileChooser* _sender, gpointer self) {
	file_selector_update_preview_cb ((FileSelector*) self);
}


static void _file_selector_selection_changed_cb_gtk_file_chooser_selection_changed (GtkFileChooser* _sender, gpointer self) {
	file_selector_selection_changed_cb ((FileSelector*) self);
}


static void _file_selector_file_activated_cb_gtk_file_chooser_file_activated (GtkFileChooser* _sender, gpointer self) {
	file_selector_file_activated_cb ((FileSelector*) self);
}


static void _file_selector_folder_changed_cb_gtk_file_chooser_current_folder_changed (GtkFileChooser* _sender, gpointer self) {
	file_selector_folder_changed_cb ((FileSelector*) self);
}


static void _file_selector_select_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	file_selector_select_clicked_cb ((FileSelector*) self);
}


static void _file_selector_cancel_clicked_cb_gtk_button_clicked (GtkButton* _sender, gpointer self) {
	file_selector_cancel_clicked_cb ((FileSelector*) self);
}


FileSelector* file_selector_construct (GType object_type) {
	FileSelector * self = NULL;
	const gchar* _tmp0_ = NULL;
	GtkFileChooserWidget* _tmp1_ = NULL;
	GtkImage* _tmp2_ = NULL;
	GtkLabel* _tmp3_ = NULL;
	GtkLabel* _tmp4_ = NULL;
	GtkLabel* _tmp5_ = NULL;
	GtkBox* _tmp6_ = NULL;
	GtkBox* _tmp7_ = NULL;
	GtkBox* _tmp8_ = NULL;
	GtkBox* _tmp9_ = NULL;
	GtkImage* _tmp10_ = NULL;
	GtkBox* _tmp11_ = NULL;
	GtkLabel* _tmp12_ = NULL;
	GtkFileChooserWidget* _tmp13_ = NULL;
	GtkBox* _tmp14_ = NULL;
	GtkFileFilter* filter = NULL;
	GtkFileFilter* _tmp15_ = NULL;
	GtkFileFilter* _tmp16_ = NULL;
	GtkFileFilter* _tmp17_ = NULL;
	GtkFileFilter* _tmp18_ = NULL;
	GtkFileChooserWidget* _tmp19_ = NULL;
	GtkFileFilter* _tmp20_ = NULL;
	GtkFileChooserWidget* _tmp21_ = NULL;
	GtkFileChooserWidget* _tmp22_ = NULL;
	GtkFileChooserWidget* _tmp23_ = NULL;
	GtkFileChooserWidget* _tmp24_ = NULL;
	GtkFileChooserWidget* _tmp25_ = NULL;
	GtkFileChooserWidget* _tmp26_ = NULL;
	GtkBox* _tmp27_ = NULL;
	GtkBox* _tmp28_ = NULL;
	GtkFileChooserWidget* _tmp29_ = NULL;
	GtkSizeGroup* button_size_group = NULL;
	GtkSizeGroup* _tmp30_ = NULL;
	const gchar* _tmp31_ = NULL;
	GtkButton* _tmp32_ = NULL;
	GtkButton* _tmp33_ = NULL;
	GtkButton* _tmp34_ = NULL;
	GtkButton* _tmp35_ = NULL;
	GtkButton* _tmp36_ = NULL;
	GtkStyleContext* _tmp37_ = NULL;
	GtkSizeGroup* _tmp38_ = NULL;
	GtkButton* _tmp39_ = NULL;
	const gchar* _tmp40_ = NULL;
	GtkButton* _tmp41_ = NULL;
	GtkButton* _tmp42_ = NULL;
	GtkSizeGroup* _tmp43_ = NULL;
	GtkButton* _tmp44_ = NULL;
	GtkSettings* _tmp45_ = NULL;
	gboolean _tmp46_ = FALSE;
	gboolean _tmp47_ = FALSE;
	GtkBox* _tmp68_ = NULL;
	GtkButton* _tmp69_ = NULL;
	self = (FileSelector*) g_object_new (object_type, NULL);
	_tmp0_ = _ ("Select Image");
	gtk_window_set_title (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), _tmp0_);
	gtk_window_set_type_hint (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), GDK_WINDOW_TYPE_HINT_DIALOG);
	_tmp1_ = (GtkFileChooserWidget*) gtk_file_chooser_widget_new (GTK_FILE_CHOOSER_ACTION_OPEN);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->file_chooser);
	self->priv->file_chooser = _tmp1_;
	_tmp2_ = (GtkImage*) gtk_image_new ();
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->preview_image);
	self->priv->preview_image = _tmp2_;
	_tmp3_ = (GtkLabel*) gtk_label_new ("");
	g_object_ref_sink (_tmp3_);
	_g_object_unref0 (self->priv->preview_label);
	self->priv->preview_label = _tmp3_;
	_tmp4_ = self->priv->preview_label;
	gtk_label_set_ellipsize (_tmp4_, PANGO_ELLIPSIZE_MIDDLE);
	_tmp5_ = self->priv->preview_label;
	gtk_label_set_max_width_chars (_tmp5_, 20);
	_tmp6_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->preview_box);
	self->priv->preview_box = _tmp6_;
	_tmp7_ = self->priv->preview_box;
	gtk_widget_set_valign (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_CENTER);
	_tmp8_ = self->priv->preview_box;
	gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_widget_get_type (), GtkWidget), 12);
	_tmp9_ = self->priv->preview_box;
	_tmp10_ = self->priv->preview_image;
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, gtk_widget_get_type (), GtkWidget));
	_tmp11_ = self->priv->preview_box;
	_tmp12_ = self->priv->preview_label;
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_widget_get_type (), GtkWidget));
	_tmp13_ = self->priv->file_chooser;
	_tmp14_ = self->priv->preview_box;
	gtk_file_chooser_set_preview_widget (G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_widget_get_type (), GtkWidget));
	_tmp15_ = gtk_file_filter_new ();
	g_object_ref_sink (_tmp15_);
	filter = _tmp15_;
	_tmp16_ = filter;
	gtk_file_filter_add_mime_type (_tmp16_, "image/png");
	_tmp17_ = filter;
	gtk_file_filter_add_mime_type (_tmp17_, "image/jpeg");
	_tmp18_ = filter;
	gtk_file_filter_add_mime_type (_tmp18_, "image/gif");
	_tmp19_ = self->priv->file_chooser;
	_tmp20_ = filter;
	gtk_file_chooser_set_filter (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), _tmp20_);
	_tmp21_ = self->priv->file_chooser;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), "update-preview", (GCallback) _file_selector_update_preview_cb_gtk_file_chooser_update_preview, self, 0);
	_tmp22_ = self->priv->file_chooser;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), "selection-changed", (GCallback) _file_selector_selection_changed_cb_gtk_file_chooser_selection_changed, self, 0);
	_tmp23_ = self->priv->file_chooser;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp23_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), "file-activated", (GCallback) _file_selector_file_activated_cb_gtk_file_chooser_file_activated, self, 0);
	_tmp24_ = self->priv->file_chooser;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp24_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), "current-folder-changed", (GCallback) _file_selector_folder_changed_cb_gtk_file_chooser_current_folder_changed, self, 0);
	_tmp25_ = self->priv->file_chooser;
	gtk_file_chooser_set_use_preview_label (G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), FALSE);
	_tmp26_ = self->priv->file_chooser;
	gtk_widget_set_vexpand (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, gtk_widget_get_type (), GtkWidget), TRUE);
	_tmp27_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 6);
	g_object_ref_sink (_tmp27_);
	_g_object_unref0 (self->priv->main_box);
	self->priv->main_box = _tmp27_;
	_tmp28_ = self->priv->main_box;
	_tmp29_ = self->priv->file_chooser;
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp28_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp29_, gtk_widget_get_type (), GtkWidget));
	_tmp30_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
	button_size_group = _tmp30_;
	_tmp31_ = _ ("Open");
	_tmp32_ = (GtkButton*) gtk_button_new_with_label (_tmp31_);
	g_object_ref_sink (_tmp32_);
	_g_object_unref0 (self->priv->select_button);
	self->priv->select_button = _tmp32_;
	_tmp33_ = self->priv->select_button;
	g_signal_connect_object (_tmp33_, "clicked", (GCallback) _file_selector_select_clicked_cb_gtk_button_clicked, self, 0);
	_tmp34_ = self->priv->select_button;
	gtk_widget_set_receives_default (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, gtk_widget_get_type (), GtkWidget), TRUE);
	_tmp35_ = self->priv->select_button;
	gtk_widget_set_can_default (G_TYPE_CHECK_INSTANCE_CAST (_tmp35_, gtk_widget_get_type (), GtkWidget), TRUE);
	_tmp36_ = self->priv->select_button;
	_tmp37_ = gtk_widget_get_style_context (G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, gtk_widget_get_type (), GtkWidget));
	gtk_style_context_add_class (_tmp37_, "suggested-action");
	_tmp38_ = button_size_group;
	_tmp39_ = self->priv->select_button;
	gtk_size_group_add_widget (_tmp38_, G_TYPE_CHECK_INSTANCE_CAST (_tmp39_, gtk_widget_get_type (), GtkWidget));
	_tmp40_ = _ ("Cancel");
	_tmp41_ = (GtkButton*) gtk_button_new_with_label (_tmp40_);
	g_object_ref_sink (_tmp41_);
	_g_object_unref0 (self->priv->cancel_button);
	self->priv->cancel_button = _tmp41_;
	_tmp42_ = self->priv->cancel_button;
	g_signal_connect_object (_tmp42_, "clicked", (GCallback) _file_selector_cancel_clicked_cb_gtk_button_clicked, self, 0);
	_tmp43_ = button_size_group;
	_tmp44_ = self->priv->cancel_button;
	gtk_size_group_add_widget (_tmp43_, G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, gtk_widget_get_type (), GtkWidget));
	_tmp45_ = gtk_settings_get_default ();
	g_object_get (_tmp45_, "gtk-dialogs-use-header", &_tmp46_, NULL);
	_tmp47_ = _tmp46_;
	if (_tmp47_) {
		GtkHeaderBar* titlebar = NULL;
		GtkHeaderBar* _tmp48_ = NULL;
		GtkHeaderBar* _tmp49_ = NULL;
		const gchar* _tmp50_ = NULL;
		GtkHeaderBar* _tmp51_ = NULL;
		GtkButton* _tmp52_ = NULL;
		GtkHeaderBar* _tmp53_ = NULL;
		GtkButton* _tmp54_ = NULL;
		GtkHeaderBar* _tmp55_ = NULL;
		_tmp48_ = (GtkHeaderBar*) gtk_header_bar_new ();
		g_object_ref_sink (_tmp48_);
		titlebar = _tmp48_;
		_tmp49_ = titlebar;
		_tmp50_ = _ ("Select Image");
		gtk_header_bar_set_title (_tmp49_, _tmp50_);
		_tmp51_ = titlebar;
		_tmp52_ = self->priv->cancel_button;
		gtk_header_bar_pack_start (_tmp51_, G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, gtk_widget_get_type (), GtkWidget));
		_tmp53_ = titlebar;
		_tmp54_ = self->priv->select_button;
		gtk_header_bar_pack_end (_tmp53_, G_TYPE_CHECK_INSTANCE_CAST (_tmp54_, gtk_widget_get_type (), GtkWidget));
		_tmp55_ = titlebar;
		gtk_window_set_titlebar (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, gtk_widget_get_type (), GtkWidget));
		_g_object_unref0 (titlebar);
	} else {
		GtkBox* button_box = NULL;
		GtkBox* _tmp56_ = NULL;
		GtkBox* _tmp57_ = NULL;
		GtkBox* _tmp58_ = NULL;
		GtkBox* _tmp59_ = NULL;
		GtkButton* _tmp60_ = NULL;
		GtkBox* _tmp61_ = NULL;
		GtkButton* _tmp62_ = NULL;
		GtkButton* _tmp63_ = NULL;
		GtkBox* _tmp64_ = NULL;
		GtkButton* _tmp65_ = NULL;
		GtkBox* _tmp66_ = NULL;
		GtkBox* _tmp67_ = NULL;
		_tmp56_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
		g_object_ref_sink (_tmp56_);
		button_box = _tmp56_;
		_tmp57_ = button_box;
		gtk_widget_set_margin_end (G_TYPE_CHECK_INSTANCE_CAST (_tmp57_, gtk_widget_get_type (), GtkWidget), 6);
		_tmp58_ = button_box;
		gtk_widget_set_margin_bottom (G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, gtk_widget_get_type (), GtkWidget), 6);
		_tmp59_ = button_box;
		gtk_widget_set_halign (G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_END);
		_tmp60_ = self->priv->cancel_button;
		gtk_widget_set_halign (G_TYPE_CHECK_INSTANCE_CAST (_tmp60_, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_END);
		_tmp61_ = button_box;
		_tmp62_ = self->priv->cancel_button;
		gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp61_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, gtk_widget_get_type (), GtkWidget));
		_tmp63_ = self->priv->select_button;
		gtk_widget_set_halign (G_TYPE_CHECK_INSTANCE_CAST (_tmp63_, gtk_widget_get_type (), GtkWidget), GTK_ALIGN_END);
		_tmp64_ = button_box;
		_tmp65_ = self->priv->select_button;
		gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, gtk_widget_get_type (), GtkWidget));
		_tmp66_ = self->priv->main_box;
		_tmp67_ = button_box;
		gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp66_, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, gtk_widget_get_type (), GtkWidget));
		_g_object_unref0 (button_box);
	}
	_tmp68_ = self->priv->main_box;
	gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_container_get_type (), GtkContainer), G_TYPE_CHECK_INSTANCE_CAST (_tmp68_, gtk_widget_get_type (), GtkWidget));
	_tmp69_ = self->priv->select_button;
	gtk_widget_grab_default (G_TYPE_CHECK_INSTANCE_CAST (_tmp69_, gtk_widget_get_type (), GtkWidget));
	gtk_window_set_default_size (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), 800, 400);
	_g_object_unref0 (button_size_group);
	_g_object_unref0 (filter);
	return self;
}


FileSelector* file_selector_new (void) {
	return file_selector_construct (TYPE_FILE_SELECTOR);
}


static void file_selector_selection_changed_cb (FileSelector* self) {
	gchar* uri = NULL;
	GtkFileChooserWidget* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	GFile* file = NULL;
	const gchar* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	GFileInfo* info = NULL;
	GFileInfo* _tmp11_ = NULL;
	GFileType _tmp12_ = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_FILE_SELECTOR (self));
	_tmp0_ = self->priv->file_chooser;
	_tmp1_ = gtk_file_chooser_get_uri (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser));
	uri = _tmp1_;
	_tmp2_ = uri;
	if (_tmp2_ == NULL) {
		_g_free0 (uri);
		return;
	}
	_tmp3_ = uri;
	_tmp4_ = g_file_new_for_uri (_tmp3_);
	file = _tmp4_;
	{
		GFileInfo* _tmp5_ = NULL;
		GFile* _tmp6_ = NULL;
		GFileInfo* _tmp7_ = NULL;
		GFileInfo* _tmp8_ = NULL;
		_tmp6_ = file;
		_tmp7_ = g_file_query_info (_tmp6_, G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_SIZE, 0, NULL, &_inner_error_);
		_tmp5_ = _tmp7_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch95_g_error;
		}
		_tmp8_ = _tmp5_;
		_tmp5_ = NULL;
		_g_object_unref0 (info);
		info = _tmp8_;
		_g_object_unref0 (_tmp5_);
	}
	goto __finally95;
	__catch95_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		g_warning ("FileSelector.vala:122: %s", _tmp10_);
		_g_error_free0 (e);
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		_g_free0 (uri);
		return;
	}
	__finally95:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		_g_free0 (uri);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp11_ = info;
	_tmp12_ = g_file_info_get_file_type (_tmp11_);
	if (_tmp12_ == G_FILE_TYPE_REGULAR) {
		gint64 size = 0LL;
		GFileInfo* _tmp13_ = NULL;
		gint64 _tmp14_ = 0LL;
		GtkButton* _tmp15_ = NULL;
		gint64 _tmp16_ = 0LL;
		guint _tmp17_ = 0U;
		_tmp13_ = info;
		_tmp14_ = g_file_info_get_size (_tmp13_);
		size = _tmp14_;
		_tmp15_ = self->priv->select_button;
		_tmp16_ = size;
		_tmp17_ = self->priv->_max_file_size;
		gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_widget_get_type (), GtkWidget), _tmp16_ < ((gint64) _tmp17_));
	} else {
		GtkButton* _tmp18_ = NULL;
		_tmp18_ = self->priv->select_button;
		gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gtk_widget_get_type (), GtkWidget), TRUE);
	}
	_g_object_unref0 (info);
	_g_object_unref0 (file);
	_g_free0 (uri);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void file_selector_update_preview_cb (FileSelector* self) {
	gchar* uri = NULL;
	GtkFileChooserWidget* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	GFile* file = NULL;
	const gchar* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	GFileInfo* info = NULL;
	GFileInfo* _tmp11_ = NULL;
	gint64 _tmp12_ = 0LL;
	guint _tmp13_ = 0U;
	const gchar* _tmp20_ = NULL;
	gboolean _tmp21_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_FILE_SELECTOR (self));
	_tmp0_ = self->priv->file_chooser;
	_tmp1_ = gtk_file_chooser_get_uri (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser));
	uri = _tmp1_;
	_tmp2_ = uri;
	if (_tmp2_ == NULL) {
		_g_free0 (uri);
		return;
	}
	_tmp3_ = uri;
	_tmp4_ = g_file_new_for_uri (_tmp3_);
	file = _tmp4_;
	{
		GFileInfo* _tmp5_ = NULL;
		GFile* _tmp6_ = NULL;
		GFileInfo* _tmp7_ = NULL;
		GFileInfo* _tmp8_ = NULL;
		_tmp6_ = file;
		_tmp7_ = g_file_query_info (_tmp6_, G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_SIZE, 0, NULL, &_inner_error_);
		_tmp5_ = _tmp7_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch96_g_error;
		}
		_tmp8_ = _tmp5_;
		_tmp5_ = NULL;
		_g_object_unref0 (info);
		info = _tmp8_;
		_g_object_unref0 (_tmp5_);
	}
	goto __finally96;
	__catch96_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		g_warning ("FileSelector.vala:145: %s", _tmp10_);
		_g_error_free0 (e);
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		_g_free0 (uri);
		return;
	}
	__finally96:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		_g_free0 (uri);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp11_ = info;
	_tmp12_ = g_file_info_get_size (_tmp11_);
	_tmp13_ = self->priv->_max_file_size;
	if (_tmp12_ > ((gint64) _tmp13_)) {
		GtkImage* _tmp14_ = NULL;
		GtkImage* _tmp15_ = NULL;
		GtkLabel* _tmp16_ = NULL;
		const gchar* _tmp17_ = NULL;
		GtkLabel* _tmp18_ = NULL;
		GtkBox* _tmp19_ = NULL;
		_tmp14_ = self->priv->preview_image;
		gtk_image_clear (_tmp14_);
		_tmp15_ = self->priv->preview_image;
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, gtk_widget_get_type (), GtkWidget));
		_tmp16_ = self->priv->preview_label;
		_tmp17_ = _ ("Max file size exceeded\n(3MB)");
		gtk_label_set_label (_tmp16_, _tmp17_);
		_tmp18_ = self->priv->preview_label;
		gtk_label_set_justify (_tmp18_, GTK_JUSTIFY_CENTER);
		_tmp19_ = self->priv->preview_box;
		gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_widget_get_type (), GtkWidget));
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		_g_free0 (uri);
		return;
	}
	_tmp20_ = uri;
	_tmp21_ = g_str_has_prefix (_tmp20_, "file://");
	if (_tmp21_) {
		GtkLabel* _tmp22_ = NULL;
		GFile* _tmp23_ = NULL;
		gchar* _tmp24_ = NULL;
		gchar* _tmp25_ = NULL;
		_tmp22_ = self->priv->preview_label;
		_tmp23_ = file;
		_tmp24_ = g_file_get_basename (_tmp23_);
		_tmp25_ = _tmp24_;
		gtk_label_set_label (_tmp22_, _tmp25_);
		_g_free0 (_tmp25_);
		{
			gint final_size = 0;
			GdkPixbuf* p = NULL;
			GFile* _tmp26_ = NULL;
			gchar* _tmp27_ = NULL;
			gchar* _tmp28_ = NULL;
			GdkPixbuf* _tmp29_ = NULL;
			GdkPixbuf* _tmp30_ = NULL;
			gint w = 0;
			GdkPixbuf* _tmp31_ = NULL;
			gint _tmp32_ = 0;
			gint h = 0;
			GdkPixbuf* _tmp33_ = NULL;
			gint _tmp34_ = 0;
			gint _tmp35_ = 0;
			gint _tmp36_ = 0;
			GdkPixbuf* _tmp47_ = NULL;
			GdkPixbuf* _tmp48_ = NULL;
			GdkPixbuf* scaled = NULL;
			GdkPixbuf* _tmp49_ = NULL;
			gint _tmp50_ = 0;
			gint _tmp51_ = 0;
			GdkPixbuf* _tmp52_ = NULL;
			GtkImage* _tmp53_ = NULL;
			GdkPixbuf* _tmp54_ = NULL;
			GtkBox* _tmp55_ = NULL;
			final_size = 130;
			_tmp26_ = file;
			_tmp27_ = g_file_get_path (_tmp26_);
			_tmp28_ = _tmp27_;
			_tmp29_ = gdk_pixbuf_new_from_file (_tmp28_, &_inner_error_);
			_tmp30_ = _tmp29_;
			_g_free0 (_tmp28_);
			p = _tmp30_;
			if (G_UNLIKELY (_inner_error_ != NULL)) {
				goto __catch97_g_error;
			}
			_tmp31_ = p;
			_tmp32_ = gdk_pixbuf_get_width (_tmp31_);
			w = _tmp32_;
			_tmp33_ = p;
			_tmp34_ = gdk_pixbuf_get_height (_tmp33_);
			h = _tmp34_;
			_tmp35_ = w;
			_tmp36_ = h;
			if (_tmp35_ > _tmp36_) {
				gdouble ratio = 0.0;
				gint _tmp37_ = 0;
				gint _tmp38_ = 0;
				gint _tmp39_ = 0;
				gint _tmp40_ = 0;
				gdouble _tmp41_ = 0.0;
				_tmp37_ = final_size;
				_tmp38_ = w;
				ratio = _tmp37_ / ((gdouble) _tmp38_);
				_tmp39_ = final_size;
				w = _tmp39_;
				_tmp40_ = h;
				_tmp41_ = ratio;
				h = (gint) (_tmp40_ * _tmp41_);
			} else {
				gdouble ratio = 0.0;
				gint _tmp42_ = 0;
				gint _tmp43_ = 0;
				gint _tmp44_ = 0;
				gdouble _tmp45_ = 0.0;
				gint _tmp46_ = 0;
				_tmp42_ = final_size;
				_tmp43_ = h;
				ratio = _tmp42_ / ((gdouble) _tmp43_);
				_tmp44_ = w;
				_tmp45_ = ratio;
				w = (gint) (_tmp44_ * _tmp45_);
				_tmp46_ = final_size;
				h = _tmp46_;
			}
			_tmp47_ = p;
			_tmp48_ = _g_object_ref0 (_tmp47_);
			_g_object_unref0 (self->priv->image);
			self->priv->image = _tmp48_;
			_tmp49_ = p;
			_tmp50_ = w;
			_tmp51_ = h;
			_tmp52_ = gdk_pixbuf_scale_simple (_tmp49_, _tmp50_, _tmp51_, GDK_INTERP_BILINEAR);
			scaled = _tmp52_;
			_tmp53_ = self->priv->preview_image;
			_tmp54_ = scaled;
			gtk_image_set_from_pixbuf (_tmp53_, _tmp54_);
			_tmp55_ = self->priv->preview_box;
			gtk_widget_show_all (G_TYPE_CHECK_INSTANCE_CAST (_tmp55_, gtk_widget_get_type (), GtkWidget));
			_g_object_unref0 (scaled);
			_g_object_unref0 (p);
		}
		goto __finally97;
		__catch97_g_error:
		{
			GError* e = NULL;
			GtkBox* _tmp56_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp56_ = self->priv->preview_box;
			gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, gtk_widget_get_type (), GtkWidget));
			_g_error_free0 (e);
		}
		__finally97:
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_object_unref0 (info);
			_g_object_unref0 (file);
			_g_free0 (uri);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	} else {
		GtkBox* _tmp57_ = NULL;
		_tmp57_ = self->priv->preview_box;
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp57_, gtk_widget_get_type (), GtkWidget));
	}
	_g_object_unref0 (info);
	_g_object_unref0 (file);
	_g_free0 (uri);
}


static void file_selector_folder_changed_cb (FileSelector* self) {
	gchar* uri = NULL;
	GtkFileChooserWidget* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	g_return_if_fail (IS_FILE_SELECTOR (self));
	_tmp0_ = self->priv->file_chooser;
	_tmp1_ = gtk_file_chooser_get_uri (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser));
	uri = _tmp1_;
	_tmp2_ = uri;
	if (_tmp2_ == NULL) {
		GtkBox* _tmp3_ = NULL;
		GtkButton* _tmp4_ = NULL;
		_tmp3_ = self->priv->preview_box;
		gtk_widget_hide (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_widget_get_type (), GtkWidget));
		_tmp4_ = self->priv->select_button;
		gtk_widget_set_sensitive (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget), FALSE);
	}
	_g_free0 (uri);
}


static void file_selector_cancel_clicked_cb (FileSelector* self) {
	g_return_if_fail (IS_FILE_SELECTOR (self));
	gtk_window_close (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow));
}


static void file_selector_select_clicked_cb (FileSelector* self) {
	g_return_if_fail (IS_FILE_SELECTOR (self));
	file_selector_choose_file (self);
}


static void file_selector_file_activated_cb (FileSelector* self) {
	g_return_if_fail (IS_FILE_SELECTOR (self));
	file_selector_choose_file (self);
}


static void file_selector_choose_file (FileSelector* self) {
	gchar* uri = NULL;
	GtkFileChooserWidget* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	GFile* file = NULL;
	const gchar* _tmp3_ = NULL;
	GFile* _tmp4_ = NULL;
	GFileInfo* info = NULL;
	GFileInfo* _tmp11_ = NULL;
	gint64 _tmp12_ = 0LL;
	guint _tmp13_ = 0U;
	GFileInfo* _tmp14_ = NULL;
	GFileType _tmp15_ = 0;
	GError * _inner_error_ = NULL;
	g_return_if_fail (IS_FILE_SELECTOR (self));
	_tmp0_ = self->priv->file_chooser;
	_tmp1_ = gtk_file_chooser_get_uri (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser));
	uri = _tmp1_;
	_tmp2_ = uri;
	if (_tmp2_ == NULL) {
		_g_free0 (uri);
		return;
	}
	_tmp3_ = uri;
	_tmp4_ = g_file_new_for_uri (_tmp3_);
	file = _tmp4_;
	{
		GFileInfo* _tmp5_ = NULL;
		GFile* _tmp6_ = NULL;
		GFileInfo* _tmp7_ = NULL;
		GFileInfo* _tmp8_ = NULL;
		_tmp6_ = file;
		_tmp7_ = g_file_query_info (_tmp6_, G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_SIZE, 0, NULL, &_inner_error_);
		_tmp5_ = _tmp7_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			goto __catch98_g_error;
		}
		_tmp8_ = _tmp5_;
		_tmp5_ = NULL;
		_g_object_unref0 (info);
		info = _tmp8_;
		_g_object_unref0 (_tmp5_);
	}
	goto __finally98;
	__catch98_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp9_ = e;
		_tmp10_ = _tmp9_->message;
		g_warning ("FileSelector.vala:217: %s", _tmp10_);
		_g_error_free0 (e);
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		_g_free0 (uri);
		return;
	}
	__finally98:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		_g_free0 (uri);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp11_ = info;
	_tmp12_ = g_file_info_get_size (_tmp11_);
	_tmp13_ = self->priv->_max_file_size;
	if (_tmp12_ > ((gint64) _tmp13_)) {
		_g_object_unref0 (info);
		_g_object_unref0 (file);
		_g_free0 (uri);
		return;
	}
	_tmp14_ = info;
	_tmp15_ = g_file_info_get_file_type (_tmp14_);
	if (_tmp15_ == G_FILE_TYPE_DIRECTORY) {
		GtkFileChooserWidget* _tmp16_ = NULL;
		GFile* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
		gchar* _tmp19_ = NULL;
		_tmp16_ = self->priv->file_chooser;
		_tmp17_ = file;
		_tmp18_ = g_file_get_path (_tmp17_);
		_tmp19_ = _tmp18_;
		gtk_file_chooser_set_current_folder (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, GTK_TYPE_FILE_CHOOSER, GtkFileChooser), _tmp19_);
		_g_free0 (_tmp19_);
	} else {
		GFileInfo* _tmp20_ = NULL;
		GFileType _tmp21_ = 0;
		_tmp20_ = info;
		_tmp21_ = g_file_info_get_file_type (_tmp20_);
		if (_tmp21_ == G_FILE_TYPE_REGULAR) {
			GFile* _tmp22_ = NULL;
			gchar* _tmp23_ = NULL;
			gchar* _tmp24_ = NULL;
			GdkPixbuf* _tmp25_ = NULL;
			_tmp22_ = file;
			_tmp23_ = g_file_get_path (_tmp22_);
			_tmp24_ = _tmp23_;
			_tmp25_ = self->priv->image;
			g_signal_emit_by_name (self, "file-selected", _tmp24_, _tmp25_);
			_g_free0 (_tmp24_);
		}
	}
	_g_object_unref0 (info);
	_g_object_unref0 (file);
	_g_free0 (uri);
}


guint file_selector_get_max_file_size (FileSelector* self) {
	guint result;
	guint _tmp0_ = 0U;
	g_return_val_if_fail (IS_FILE_SELECTOR (self), 0U);
	_tmp0_ = self->priv->_max_file_size;
	result = _tmp0_;
	return result;
}


void file_selector_set_max_file_size (FileSelector* self, guint value) {
	guint _tmp0_ = 0U;
	g_return_if_fail (IS_FILE_SELECTOR (self));
	_tmp0_ = value;
	self->priv->_max_file_size = _tmp0_;
	g_object_notify ((GObject *) self, "max-file-size");
}


static void g_cclosure_user_marshal_VOID__STRING_OBJECT (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_OBJECT) (gpointer data1, const char* arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__STRING_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_OBJECT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_object (param_values + 2), data2);
}


static void file_selector_class_init (FileSelectorClass * klass) {
	file_selector_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (FileSelectorPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_file_selector_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_file_selector_set_property;
	G_OBJECT_CLASS (klass)->finalize = file_selector_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), FILE_SELECTOR_MAX_FILE_SIZE, g_param_spec_uint ("max-file-size", "max-file-size", "max-file-size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_signal_new ("file_selected", TYPE_FILE_SELECTOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_OBJECT, G_TYPE_NONE, 2, G_TYPE_STRING, GDK_TYPE_PIXBUF);
}


static void file_selector_instance_init (FileSelector * self) {
	self->priv = FILE_SELECTOR_GET_PRIVATE (self);
	self->priv->_max_file_size = (guint) TWITTER_MAX_BYTES_PER_IMAGE;
	self->priv->image = NULL;
}


static void file_selector_finalize (GObject* obj) {
	FileSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_FILE_SELECTOR, FileSelector);
	_g_object_unref0 (self->priv->image);
	_g_object_unref0 (self->priv->file_chooser);
	_g_object_unref0 (self->priv->main_box);
	_g_object_unref0 (self->priv->preview_box);
	_g_object_unref0 (self->priv->preview_image);
	_g_object_unref0 (self->priv->preview_label);
	_g_object_unref0 (self->priv->select_button);
	_g_object_unref0 (self->priv->cancel_button);
	G_OBJECT_CLASS (file_selector_parent_class)->finalize (obj);
}


GType file_selector_get_type (void) {
	static volatile gsize file_selector_type_id__volatile = 0;
	if (g_once_init_enter (&file_selector_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FileSelectorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) file_selector_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FileSelector), 0, (GInstanceInitFunc) file_selector_instance_init, NULL };
		GType file_selector_type_id;
		file_selector_type_id = g_type_register_static (gtk_window_get_type (), "FileSelector", &g_define_type_info, 0);
		g_once_init_leave (&file_selector_type_id__volatile, file_selector_type_id);
	}
	return file_selector_type_id__volatile;
}


static void _vala_file_selector_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	FileSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FILE_SELECTOR, FileSelector);
	switch (property_id) {
		case FILE_SELECTOR_MAX_FILE_SIZE:
		g_value_set_uint (value, file_selector_get_max_file_size (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_file_selector_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	FileSelector * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_FILE_SELECTOR, FileSelector);
	switch (property_id) {
		case FILE_SELECTOR_MAX_FILE_SIZE:
		file_selector_set_max_file_size (self, g_value_get_uint (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



