/* MediaDialog.c generated by valac 0.30.2, the Vala compiler
 * generated from MediaDialog.vala, do not modify */

/*  This file is part of corebird, a Gtk+ linux Twitter client.
 *  Copyright (C) 2013 Timm Bäder
 *
 *  corebird is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  corebird is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with corebird.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include "CbTweet.h"
#include "Media.h"
#include <gdk/gdk.h>


#define TYPE_MEDIA_DIALOG (media_dialog_get_type ())
#define MEDIA_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_DIALOG, MediaDialog))
#define MEDIA_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_DIALOG, MediaDialogClass))
#define IS_MEDIA_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_DIALOG))
#define IS_MEDIA_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_DIALOG))
#define MEDIA_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_DIALOG, MediaDialogClass))

typedef struct _MediaDialog MediaDialog;
typedef struct _MediaDialogClass MediaDialogClass;
typedef struct _MediaDialogPrivate MediaDialogPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_MEDIA_VIDEO_WIDGET (media_video_widget_get_type ())
#define MEDIA_VIDEO_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_VIDEO_WIDGET, MediaVideoWidget))
#define MEDIA_VIDEO_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_VIDEO_WIDGET, MediaVideoWidgetClass))
#define IS_MEDIA_VIDEO_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_VIDEO_WIDGET))
#define IS_MEDIA_VIDEO_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_VIDEO_WIDGET))
#define MEDIA_VIDEO_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_VIDEO_WIDGET, MediaVideoWidgetClass))

typedef struct _MediaVideoWidget MediaVideoWidget;
typedef struct _MediaVideoWidgetClass MediaVideoWidgetClass;

#define TYPE_MEDIA_IMAGE_WIDGET (media_image_widget_get_type ())
#define MEDIA_IMAGE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MEDIA_IMAGE_WIDGET, MediaImageWidget))
#define MEDIA_IMAGE_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MEDIA_IMAGE_WIDGET, MediaImageWidgetClass))
#define IS_MEDIA_IMAGE_WIDGET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MEDIA_IMAGE_WIDGET))
#define IS_MEDIA_IMAGE_WIDGET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MEDIA_IMAGE_WIDGET))
#define MEDIA_IMAGE_WIDGET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MEDIA_IMAGE_WIDGET, MediaImageWidgetClass))

typedef struct _MediaImageWidget MediaImageWidget;
typedef struct _MediaImageWidgetClass MediaImageWidgetClass;

struct _MediaDialog {
	GtkWindow parent_instance;
	MediaDialogPrivate * priv;
};

struct _MediaDialogClass {
	GtkWindowClass parent_class;
};

struct _MediaDialogPrivate {
	GtkFrame* frame;
	CbTweet* tweet;
	gint cur_index;
};


static gpointer media_dialog_parent_class = NULL;

GType media_dialog_get_type (void) G_GNUC_CONST;
#define MEDIA_DIALOG_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_MEDIA_DIALOG, MediaDialogPrivate))
enum  {
	MEDIA_DIALOG_DUMMY_PROPERTY
};
MediaDialog* media_dialog_new (CbTweet* tweet, gint start_media_index);
MediaDialog* media_dialog_construct (GType object_type, CbTweet* tweet, gint start_media_index);
static void media_dialog_change_media (MediaDialog* self, CbMedia* media);
MediaVideoWidget* media_video_widget_new (CbMedia* media);
MediaVideoWidget* media_video_widget_construct (GType object_type, CbMedia* media);
GType media_video_widget_get_type (void) G_GNUC_CONST;
void media_video_widget_init (MediaVideoWidget* self);
MediaImageWidget* media_image_widget_new (CbMedia* media);
MediaImageWidget* media_image_widget_construct (GType object_type, CbMedia* media);
GType media_image_widget_get_type (void) G_GNUC_CONST;
static void media_dialog_next_media (MediaDialog* self);
static void media_dialog_previous_media (MediaDialog* self);
static gboolean media_dialog_key_press_event_cb (MediaDialog* self, GdkEventKey* evt);
static gboolean _media_dialog_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self);
static gboolean media_dialog_button_press_event_cb (MediaDialog* self);
static gboolean _media_dialog_button_press_event_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self);
static gboolean media_dialog_leave_notify_cb (MediaDialog* self);
static gboolean _media_dialog_leave_notify_cb_gtk_widget_leave_notify_event (GtkWidget* _sender, GdkEventCrossing* event, gpointer self);
static gboolean media_dialog_enter_notify_cb (MediaDialog* self);
static gboolean _media_dialog_enter_notify_cb_gtk_widget_enter_notify_event (GtkWidget* _sender, GdkEventCrossing* event, gpointer self);
static void media_dialog_finalize (GObject* obj);


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


MediaDialog* media_dialog_construct (GType object_type, CbTweet* tweet, gint start_media_index) {
	MediaDialog * self = NULL;
	CbMedia* cur_media = NULL;
	CbTweet* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	CbMedia** _tmp2_ = NULL;
	gint _tmp3_ = 0;
	CbMedia* _tmp4_ = NULL;
	CbMedia* _tmp5_ = NULL;
	CbTweet* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	g_return_val_if_fail (CB_IS_TWEET (tweet), NULL);
	self = (MediaDialog*) g_object_new (object_type, NULL);
	_tmp0_ = tweet;
	_tmp2_ = cb_tweet_get_medias (_tmp0_, &_tmp1_);
	_tmp3_ = start_media_index;
	_tmp4_ = _tmp2_[_tmp3_];
	_tmp5_ = _g_object_ref0 (_tmp4_);
	cur_media = _tmp5_;
	_tmp6_ = tweet;
	self->priv->tweet = _tmp6_;
	_tmp7_ = start_media_index;
	self->priv->cur_index = _tmp7_;
	media_dialog_change_media (self, cur_media);
	_g_object_unref0 (cur_media);
	return self;
}


MediaDialog* media_dialog_new (CbTweet* tweet, gint start_media_index) {
	return media_dialog_construct (TYPE_MEDIA_DIALOG, tweet, start_media_index);
}


static void media_dialog_change_media (MediaDialog* self, CbMedia* media) {
	GtkWidget* cur_child = NULL;
	GtkFrame* _tmp0_ = NULL;
	GtkWidget* _tmp1_ = NULL;
	GtkWidget* _tmp2_ = NULL;
	gint cur_width = 0;
	gint cur_height = 0;
	gint new_width = 0;
	gint new_height = 0;
	GtkFrame* _tmp3_ = NULL;
	GtkWidget* _tmp4_ = NULL;
	GtkWidget* new_widget = NULL;
	CbMedia* _tmp10_ = NULL;
	gboolean _tmp11_ = FALSE;
	GtkWidget* _tmp21_ = NULL;
	GtkWidget* _tmp22_ = NULL;
	gint _tmp23_ = 0;
	gint _tmp24_ = 0;
	gboolean _tmp25_ = FALSE;
	gboolean _tmp26_ = FALSE;
	gboolean _tmp27_ = FALSE;
	gint _tmp28_ = 0;
	gint _tmp29_ = 0;
	g_return_if_fail (IS_MEDIA_DIALOG (self));
	g_return_if_fail (CB_IS_MEDIA (media));
	_tmp0_ = self->priv->frame;
	_tmp1_ = gtk_bin_get_child (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_bin_get_type (), GtkBin));
	_tmp2_ = _g_object_ref0 (_tmp1_);
	cur_child = _tmp2_;
	cur_width = 0;
	cur_height = 0;
	_tmp3_ = self->priv->frame;
	_tmp4_ = gtk_bin_get_child (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_bin_get_type (), GtkBin));
	if (_tmp4_ != NULL) {
		GtkFrame* _tmp5_ = NULL;
		GtkWidget* _tmp6_ = NULL;
		GtkWidget* _tmp7_ = NULL;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		_tmp5_ = self->priv->frame;
		_tmp6_ = cur_child;
		gtk_container_remove (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_container_get_type (), GtkContainer), _tmp6_);
		_tmp7_ = cur_child;
		gtk_widget_get_size_request (_tmp7_, &_tmp8_, &_tmp9_);
		cur_width = _tmp8_;
		cur_height = _tmp9_;
	}
	new_widget = NULL;
	_tmp10_ = media;
	_tmp11_ = cb_media_is_video (_tmp10_);
	if (_tmp11_) {
		CbMedia* _tmp12_ = NULL;
		MediaVideoWidget* _tmp13_ = NULL;
		GtkFrame* _tmp14_ = NULL;
		GtkWidget* _tmp15_ = NULL;
		GtkWidget* _tmp16_ = NULL;
		_tmp12_ = media;
		_tmp13_ = media_video_widget_new (_tmp12_);
		g_object_ref_sink (_tmp13_);
		_g_object_unref0 (new_widget);
		new_widget = G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gtk_widget_get_type (), GtkWidget);
		_tmp14_ = self->priv->frame;
		_tmp15_ = new_widget;
		gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, gtk_container_get_type (), GtkContainer), _tmp15_);
		_tmp16_ = new_widget;
		media_video_widget_init (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, TYPE_MEDIA_VIDEO_WIDGET, MediaVideoWidget));
	} else {
		CbMedia* _tmp17_ = NULL;
		MediaImageWidget* _tmp18_ = NULL;
		GtkFrame* _tmp19_ = NULL;
		GtkWidget* _tmp20_ = NULL;
		_tmp17_ = media;
		_tmp18_ = media_image_widget_new (_tmp17_);
		g_object_ref_sink (_tmp18_);
		_g_object_unref0 (new_widget);
		new_widget = G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, gtk_widget_get_type (), GtkWidget);
		_tmp19_ = self->priv->frame;
		_tmp20_ = new_widget;
		gtk_container_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, gtk_container_get_type (), GtkContainer), _tmp20_);
	}
	_tmp21_ = new_widget;
	gtk_widget_show_all (_tmp21_);
	_tmp22_ = new_widget;
	gtk_widget_get_size_request (_tmp22_, &_tmp23_, &_tmp24_);
	new_width = _tmp23_;
	new_height = _tmp24_;
	_tmp28_ = new_width;
	_tmp29_ = cur_width;
	if (_tmp28_ != _tmp29_) {
		_tmp27_ = TRUE;
	} else {
		gint _tmp30_ = 0;
		gint _tmp31_ = 0;
		_tmp30_ = new_height;
		_tmp31_ = cur_height;
		_tmp27_ = _tmp30_ != _tmp31_;
	}
	if (_tmp27_) {
		gint _tmp32_ = 0;
		_tmp32_ = new_width;
		_tmp26_ = _tmp32_ > 0;
	} else {
		_tmp26_ = FALSE;
	}
	if (_tmp26_) {
		gint _tmp33_ = 0;
		_tmp33_ = new_height;
		_tmp25_ = _tmp33_ > 0;
	} else {
		_tmp25_ = FALSE;
	}
	if (_tmp25_) {
		gint _tmp34_ = 0;
		gint _tmp35_ = 0;
		_tmp34_ = new_width;
		_tmp35_ = new_height;
		gtk_window_resize (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_window_get_type (), GtkWindow), _tmp34_, _tmp35_);
	}
	gtk_widget_queue_resize (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	_g_object_unref0 (new_widget);
	_g_object_unref0 (cur_child);
}


static void media_dialog_next_media (MediaDialog* self) {
	gint _tmp0_ = 0;
	CbTweet* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	CbMedia** _tmp3_ = NULL;
	g_return_if_fail (IS_MEDIA_DIALOG (self));
	_tmp0_ = self->priv->cur_index;
	_tmp1_ = self->priv->tweet;
	_tmp3_ = cb_tweet_get_medias (_tmp1_, &_tmp2_);
	if (_tmp0_ < (_tmp2_ - 1)) {
		gint _tmp4_ = 0;
		CbTweet* _tmp5_ = NULL;
		gint _tmp6_ = 0;
		CbMedia** _tmp7_ = NULL;
		gint _tmp8_ = 0;
		CbMedia* _tmp9_ = NULL;
		_tmp4_ = self->priv->cur_index;
		self->priv->cur_index = _tmp4_ + 1;
		_tmp5_ = self->priv->tweet;
		_tmp7_ = cb_tweet_get_medias (_tmp5_, &_tmp6_);
		_tmp8_ = self->priv->cur_index;
		_tmp9_ = _tmp7_[_tmp8_];
		media_dialog_change_media (self, _tmp9_);
	}
}


static void media_dialog_previous_media (MediaDialog* self) {
	gint _tmp0_ = 0;
	g_return_if_fail (IS_MEDIA_DIALOG (self));
	_tmp0_ = self->priv->cur_index;
	if (_tmp0_ > 0) {
		gint _tmp1_ = 0;
		CbTweet* _tmp2_ = NULL;
		gint _tmp3_ = 0;
		CbMedia** _tmp4_ = NULL;
		gint _tmp5_ = 0;
		CbMedia* _tmp6_ = NULL;
		_tmp1_ = self->priv->cur_index;
		self->priv->cur_index = _tmp1_ - 1;
		_tmp2_ = self->priv->tweet;
		_tmp4_ = cb_tweet_get_medias (_tmp2_, &_tmp3_);
		_tmp5_ = self->priv->cur_index;
		_tmp6_ = _tmp4_[_tmp5_];
		media_dialog_change_media (self, _tmp6_);
	}
}


static gboolean media_dialog_key_press_event_cb (MediaDialog* self, GdkEventKey* evt) {
	gboolean result = FALSE;
	GdkEventKey* _tmp0_ = NULL;
	guint _tmp1_ = 0U;
	g_return_val_if_fail (IS_MEDIA_DIALOG (self), FALSE);
	g_return_val_if_fail (evt != NULL, FALSE);
	_tmp0_ = evt;
	_tmp1_ = _tmp0_->keyval;
	if (_tmp1_ == ((guint) GDK_KEY_Left)) {
		media_dialog_previous_media (self);
	} else {
		GdkEventKey* _tmp2_ = NULL;
		guint _tmp3_ = 0U;
		_tmp2_ = evt;
		_tmp3_ = _tmp2_->keyval;
		if (_tmp3_ == ((guint) GDK_KEY_Right)) {
			media_dialog_next_media (self);
		} else {
			gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
		}
	}
	result = GDK_EVENT_STOP;
	return result;
}


static gboolean _media_dialog_key_press_event_cb_gtk_widget_key_press_event (GtkWidget* _sender, GdkEventKey* event, gpointer self) {
	gboolean result;
	result = media_dialog_key_press_event_cb ((MediaDialog*) self, event);
	return result;
}


static gboolean media_dialog_button_press_event_cb (MediaDialog* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_MEDIA_DIALOG (self), FALSE);
	gtk_widget_destroy (G_TYPE_CHECK_INSTANCE_CAST (self, gtk_widget_get_type (), GtkWidget));
	result = GDK_EVENT_STOP;
	return result;
}


static gboolean _media_dialog_button_press_event_cb_gtk_widget_button_press_event (GtkWidget* _sender, GdkEventButton* event, gpointer self) {
	gboolean result;
	result = media_dialog_button_press_event_cb ((MediaDialog*) self);
	return result;
}


static gboolean media_dialog_leave_notify_cb (MediaDialog* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_MEDIA_DIALOG (self), FALSE);
	result = GDK_EVENT_PROPAGATE;
	return result;
}


static gboolean _media_dialog_leave_notify_cb_gtk_widget_leave_notify_event (GtkWidget* _sender, GdkEventCrossing* event, gpointer self) {
	gboolean result;
	result = media_dialog_leave_notify_cb ((MediaDialog*) self);
	return result;
}


static gboolean media_dialog_enter_notify_cb (MediaDialog* self) {
	gboolean result = FALSE;
	g_return_val_if_fail (IS_MEDIA_DIALOG (self), FALSE);
	result = GDK_EVENT_PROPAGATE;
	return result;
}


static gboolean _media_dialog_enter_notify_cb_gtk_widget_enter_notify_event (GtkWidget* _sender, GdkEventCrossing* event, gpointer self) {
	gboolean result;
	result = media_dialog_enter_notify_cb ((MediaDialog*) self);
	return result;
}


static void media_dialog_class_init (MediaDialogClass * klass) {
	gint MediaDialog_private_offset;
	media_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (MediaDialogPrivate));
	G_OBJECT_CLASS (klass)->finalize = media_dialog_finalize;
	MediaDialog_private_offset = g_type_class_get_instance_private_offset (klass);
	gtk_widget_class_set_template_from_resource (GTK_WIDGET_CLASS (klass), "/org/baedert/corebird/ui/media-dialog.ui");
	gtk_widget_class_bind_template_child_full (GTK_WIDGET_CLASS (klass), "frame", FALSE, MediaDialog_private_offset + G_STRUCT_OFFSET (MediaDialogPrivate, frame));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "key_press_event_cb", G_CALLBACK(_media_dialog_key_press_event_cb_gtk_widget_key_press_event));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "button_press_event_cb", G_CALLBACK(_media_dialog_button_press_event_cb_gtk_widget_button_press_event));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "leave_notify_cb", G_CALLBACK(_media_dialog_leave_notify_cb_gtk_widget_leave_notify_event));
	gtk_widget_class_bind_template_callback_full (GTK_WIDGET_CLASS (klass), "enter_notify_cb", G_CALLBACK(_media_dialog_enter_notify_cb_gtk_widget_enter_notify_event));
}


static void media_dialog_instance_init (MediaDialog * self) {
	self->priv = MEDIA_DIALOG_GET_PRIVATE (self);
	self->priv->cur_index = 0;
	gtk_widget_init_template (GTK_WIDGET (self));
}


static void media_dialog_finalize (GObject* obj) {
	MediaDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MEDIA_DIALOG, MediaDialog);
	_g_object_unref0 (self->priv->frame);
	G_OBJECT_CLASS (media_dialog_parent_class)->finalize (obj);
}


GType media_dialog_get_type (void) {
	static volatile gsize media_dialog_type_id__volatile = 0;
	if (g_once_init_enter (&media_dialog_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (MediaDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) media_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MediaDialog), 0, (GInstanceInitFunc) media_dialog_instance_init, NULL };
		GType media_dialog_type_id;
		media_dialog_type_id = g_type_register_static (gtk_window_get_type (), "MediaDialog", &g_define_type_info, 0);
		g_once_init_leave (&media_dialog_type_id__volatile, media_dialog_type_id);
	}
	return media_dialog_type_id__volatile;
}



